\subsection{Presentation $k$-means}

\begin{frame}{$k$-means Clustering Problem}

\begin{block}{Partition data $\in \mathbb{R}^{n \times m}$ into $k$ clusters $C_1 \ldots C_k$}
$n$ (resp. $m$): number of points (resp. attributes)

$d$: Euclidean distance

\begin{equation*}
\argmin\limits_C \sum\limits_{i=1}^k \sum\limits_{p \in C_i} d(p, mean(C_i))
\end{equation*}

\end{block}

\begin{columns}
\begin{column}{0.5\textwidth}

\textbf{Examples of applications}

Segmentation

Communities in social networks

Market research

Gene sequence analysis

\end{column}

\begin{column}{0.5\textwidth}


\begin{figure}
	\centering
	\includegraphics[scale=0.25]{kmeans_demo}
\end{figure}

\end{column}
\end{columns}

\end{frame}

\begin{frame}[fragile]{$k$-means Standard Algorithm \cite{lloyd1982least} }

\begin{figure}
\centering
\begin{algorithmic}[1]
\Function{$k$-means}{\(k\), data, $\delta$}
\State Choose \( \tilde{C} := \left( \tilde{c_1} \ldots \tilde{c_k} \right) \) initial centroids
\Repeat
\State \( C = \tilde{C} \)
%\algemph{
\ForAll {point \( p \in \)data}
	\State \textcolor{red}{ \( j := \argmin_i \, d(p, c_i) \) }
	\Comment {Find nearest cluster}
	\State \textcolor{red}{ Assign \( p \) to cluster \( C_j \) }
\EndFor
%}
\ForAll {\( i\) in \( \{ 1 \ldots k \} \)}
	\State \( \tilde{c_i} = mean(p \in C_i) \)
	\Comment {Compute new centroids}
\EndFor
\Until \( \Vert \tilde{C} - C \Vert \leq \delta \)
\Comment {Convergence criteria}
\State \Return \( \tilde{C} \)
\Comment {Return the final centroids}
\EndFunction
\end{algorithmic}
%\caption{$k$-means Standard Algorithm}
\label{alg:kmeans}
\end{figure}

\end{frame}

\subsection{Implementation on \upmem{}}

%\begin{frame}{\(k\)-means algorithm on \upmem{}}

%\begin{block}{}
%The distances computation can be parallelized on the DPUs
%\end{block}
%
%\pause
%
%\begin{columns}
%\begin{column}{0.5\textwidth}
%
%\begin{algorithmic}
%\Function{main}{$\text{data}$, $k$}
%\State Send $\text{data}$ to DPUs
%\State $C$ = Initialize $k$ centroids.
%\Repeat
%\ForAll{DPU}
%\State DPU\_fun($C$)
%\EndFor
%\State Gather results
%\State Recompute $C$
%\Until{Convergence criteria}
%\EndFunction
%\end{algorithmic}
%\end{column}
%
%\begin{column}{0.5\textwidth}
%\begin{algorithmic}
%\Function{DPU\_fun}{$C$}
%\ForAll{$\text{point} \in \text{data}_i$}
%\State assign nearest centroid
%\EndFor
%\EndFunction
%\end{algorithmic}
%
%\end{column}
%\end{columns}
%
%\end{frame}

\begin{frame}{\(k\)-means algorithm on \upmem{}}

\begin{figure}
	\centering
	\includegraphics{algo}
	\label{alg:kmeans_on_upmem}
\end{figure}

\vfill

\begin{center}
    The points are distributed across the DPUs.
\end{center}

\vfill

%Transition
  \pause
  \textit{Data parallelization of the standard algorithm, can it be improved?}

\end{frame}

